#NoEnv  ; Recommended for performance and compatibility with future AutoHotkey releases.
#Warn  ; Enable warnings to assist with detecting common errors.
#Persistent ; Only the user can kill the application
SendMode Input  ; Recommended for new scripts due to its superior speed and reliability.
StringCaseSense, On ; Match strings with case.
SetWorkingDir %A_ScriptDir%
CoordMode, ToolTip, Relative
#MaxThreadsPerHotkey 2

; User Config
_timeZoneChange = 15										; Time in minutes until zonechange

_zone_to_clean1 = the_docks									; enter desired Zone 1 (see coordinates.ini[Exiled Bot] to see exact writings of the different zones)
_zone_to_clean_act1 = 3										; enter desired act for Zone 1
_zone_to_clean_difficulty1 = 3								; enter desired difficulty for Zone 1 (1=normal, 2=cruel, 3=merciless)

_zone_to_clean2 = the_city_of_sarn							; enter desired Zone 2 (see coordinates.ini[Exiled Bot] to see exact writings of the different zones)
_zone_to_clean_act2 = 3										; enter desired act for Zone 2
_zone_to_clean_difficulty2 = 3								; enter desired difficulty for Zone 2 (1=normal, 2=cruel, 3=merciless)

_zone_to_clean3 = barracks									; enter desired Zone 3 (see coordinates.ini[Exiled Bot] to see exact writings of the different zones)
_zone_to_clean_act3 = 3										; enter desired act for Zone 3
_zone_to_clean_difficulty3 = 3								; enter desired difficulty for Zone 3 (1=normal, 2=cruel, 3=merciless)

_zone_to_clean4 = lunaris_temple							; enter desired Zone 4 (see coordinates.ini[Exiled Bot] to see exact writings of the different zones)
_zone_to_clean_act4 = 3										; enter desired act for Zone 4
_zone_to_clean_difficulty4 = 3								; enter desired difficulty for Zone 4 (1=normal, 2=cruel, 3=merciless)

_zone_to_clean5 = the_library								; enter desired Zone 5 (see coordinates.ini[Exiled Bot] to see exact writings of the different zones)
_zone_to_clean_act5 = 3										; enter desired act for Zone 5
_zone_to_clean_difficulty5 = 3								; enter desired difficulty for Zone 5 (1=normal, 2=cruel, 3=merciless)

_stash_tab_to_use1 = 1										; Number of the first stash tab to use
_stash_tab_to_use2 = 2										; Number of the second stash tab to use
_stash_tab_to_use3 = 3										; Number of the third stash tab to use

_path_bot = K:\Path of Exile\Tools\EB ALTUELL				; Path to your Exiled.Bot
_path_poe = K:\Path of Exile								; Path where is installed poe (don't include game exe)
_name_poe = PathOfExile.exe									; Name of the game exe
_name_bot = ExiledBot GUI.exe								; Name of the ExiledBot exe
_name_poe_win = Path of Exile								; Name of the window when you run game exe
_name_bot_win = Exiled Bot (Elite)							; Name of the window when you run exilebot exe
_profile_bot = immo											; Name of the Exiled Bot profile used

_EBReload = F11												; EB Hotkey to reload ini
_EBPause = F12												; EB Hotkey to pause/unpause the bot

; some needed calculations
_timeZoneChangeUser := ((_timeZoneChange * 1000) * 60) + 2000
_timeZoneChangeSec := (_timeZoneChange * 60)
IniRead, currZone, %_path_bot%\Configuration\%_profile_bot%\config.ini, general, zone_to_clean
IniRead, currStashTab, %_path_bot%\Configuration\%_profile_bot%\config.ini, stashing, stash_tab_to_use

; getting the difficulty names
if (_zone_to_clean_difficulty1=1)
{
	difficulty1 = Normal
}
	else if (_zone_to_clean_difficulty1=2)	
{
	difficulty1 = Cruel
}
	else
{
	difficulty1 = Merciless
}
	
if (_zone_to_clean_difficulty2=1)
{
	difficulty2 = Normal
}
	else if (_zone_to_clean_difficulty2=2)
{
	difficulty2 = Cruel
}
	else
{
	difficulty2 = Merciless
}
	
; Menu Entries
Menu1 = ExiledBot.Zone.Changer.
ver = v1.6
EBVer = Exiled Bot Beta v0.13e
Menu2 = UserConfig:
Menu3 = zonechanging every: %_timeZoneChange% Minutes
Menu4 = Zone 1: %_zone_to_clean1% - Act%_zone_to_clean_act1%/%difficulty1%
Menu5 = Zone 2: %_zone_to_clean2% - Act%_zone_to_clean_act2%/%difficulty2%
Menu6 = Zone 3: %_zone_to_clean3% - Act%_zone_to_clean_act2%/%difficulty2%
Menu7 = Zone 4: %_zone_to_clean4% - Act%_zone_to_clean_act2%/%difficulty2%
Menu8 = Zone 5: %_zone_to_clean5% - Act%_zone_to_clean_act2%/%difficulty2%
Menu9 = Stating Zone was: %currZone%

; Some various fancy tray icon stuff.
	Menu, tray, Tip, %Menu1%%ver%`nchanging zones since 2013
	Menu, tray, NoStandard
	Menu, tray, add, %Menu1%%ver%, RemoveTooltip
	Menu, tray, disable, %Menu1%%ver%
	Menu, tray, add, for %EBVer%, RemoveTooltip
	Menu, tray, disable, for %EBVer%
	Menu, tray, add
	Menu, tray, add, %Menu2%, RemoveTooltip
	Menu, tray, disable, %Menu2%
	Menu, tray, add, %Menu3%, RemoveTooltip
	Menu, tray, disable, %Menu3%
	Menu, tray, add, %Menu4%, RemoveTooltip
	Menu, tray, disable, %Menu4%
	Menu, tray, add, %Menu5%, RemoveTooltip
	Menu, tray, disable, %Menu5%
	Menu, tray, add, %Menu6%, RemoveTooltip
	Menu, tray, disable, %Menu6%
	Menu, tray, add, %Menu7%, RemoveTooltip
	Menu, tray, disable, %Menu7%
	Menu, tray, add, %Menu8%, RemoveTooltip
	Menu, tray, disable, %Menu8%
	Menu, tray, add
	Menu, tray, add, %Menu9%, RemoveTooltip
	Menu, tray, disable, %Menu9%
	Menu, tray, add
	Menu, tray, add, Pause (F8), MyPause
	Menu, tray, add, Exit (F9), ExitSub
	
WinMinimizeAll
Sleep 2000

; autostart Path of Exile on Scriptstart
IfWinNotExist, %_name_poe_win%
{
	TrayTip, , Starting Path of Exile , 1
	Sleep 1000
	Run, %_name_poe%, %_path_poe%, , PoE_PID
	if ErrorLevel = ERROR
	{
		MsgBox Cant open %_path_poe%\%_name_poe%
		exitapp	
	}
	WinWait, ahk_pid %PoE_PID%,,3	
	WinMove, ahk_pid %PoE_PID%, 1, 1 
}
else
{
	TrayTip, , Path of Exile already running , 1
	Sleep 1000
	WinGet, PoE_PID, PID, %_name_poe_win%
	WinWait, ahk_pid %PoE_PID%,,3	
	WinMove, ahk_pid %PoE_PID%, 1, 1 
}
sleep 10000

; autostart Exiled Bot on Scriptstart
IfWinNotExist, %_name_bot_win%
{
	TrayTip, , Starting Exiled Bot , 1
	Sleep 1000
	Run, %_name_bot%, %_path_bot%, , EB_PID
	if ErrorLevel = ERROR
	{
		MsgBox Cant open %_path_bot%\%_name_bot%
		exitapp
	}
	Sleep 5000
	WinActivate, %_name_bot_win%
	ControlClick, ComboBox1, %_name_bot_win%,, Left, 1,  NA
	sleep 200
	SendInput, %_profile_bot%
	sleep 200
	SendInput, {Enter}
	sleep 200
	ControlClick, Button2, %_name_bot_win%,, Left, 1,  NA
	sleep 200
	ControlClick, Button3, %_name_bot_win%,, Left, 1,  NA
	TrayTip, , Starting to bot! , 1
}
else
{
	TrayTip, , Exiled Bot already running , 1
	Sleep 1000
	WinActivate, %_name_bot_win%
	ControlClick, ComboBox1, %_name_bot_win%,, Left, 1,  NA
	sleep 200
	SendInput, %_profile_bot%
	sleep 200
	SendInput, {Enter}
	sleep 200
	ControlClick, Button2, %_name_bot_win%,, Left, 1,  NA
	sleep 200
	ControlClick, Button3, %_name_bot_win%,, Left, 1,  NA
	TrayTip, , Starting to bot! , 1
}
WinActivate, %_name_poe_win%
Sleep 5000

; Main zoneChanging loop
TMP := Random(1,5)
SetTimer, ZC, %_timeZoneChangeUser%
ZC:
	; stash tab switching;
	if (currStashTab = _stash_tab_to_use1)
	{
		IniWrite, %_stash_tab_to_use2%, %_path_bot%\Configuration\%_profile_bot%\config.ini, stashing, stash_tab_to_use
		currStashTab = %_stash_tab_to_use2%
	}
	else if (currStashTab = _stash_tab_to_use2)
	{
		IniWrite, %_stash_tab_to_use3%, %_path_bot%\Configuration\%_profile_bot%\config.ini, stashing, stash_tab_to_use
		currStashTab = %_stash_tab_to_use3%
	}
	else
	{
		IniWrite, %_stash_tab_to_use1%, %_path_bot%\Configuration\%_profile_bot%\config.ini, stashing, stash_tab_to_use
		currStashTab = %_stash_tab_to_use1%
	}
	sleep 200
	
	; trying to randomize the zones	
	RND := Random(1,5)
	
	if (TMP = RND)
	{
		RND := Random(1,5)
	}
	else
	{
		GoSub, ZTC%RND%
	}
	return
	
	; changing the zone to Zone1
	ZTC1:
		IfWinExist, %_name_bot_win%
		{
			WinActivate, %_name_poe_win%

			IniWrite, %_zone_to_clean_act1%, %_path_bot%\Configuration\%_profile_bot%\config.ini, general, zone_to_clean_act
			IniWrite, %_zone_to_clean_difficulty1%, %_path_bot%\Configuration\%_profile_bot%\config.ini, general, zone_to_clean_difficulty
			IniWrite, %_zone_to_clean1%, %_path_bot%\Configuration\%_profile_bot%\config.ini, general, zone_to_clean
			currZone = %_zone_to_clean1%
			TMP = 1
				
			sleep 200
			Send {%_EBReload%}
			TrayTip, , Zone changed! , 2
		}
		
		SetTimer, RemoveTT, 1000 
		_timeZoneChangeSec := ((_timeZoneChange * 60) -2)
	return

	; changing the zone to Zone2
	ZTC2:
		IfWinExist, %_name_bot_win%
		{
			WinActivate, %_name_poe_win%

			IniWrite, %_zone_to_clean_act2%, %_path_bot%\Configuration\%_profile_bot%\config.ini, general, zone_to_clean_act
			IniWrite, %_zone_to_clean_difficulty2%, %_path_bot%\Configuration\%_profile_bot%\config.ini, general, zone_to_clean_difficulty
			IniWrite, %_zone_to_clean2%, %_path_bot%\Configuration\%_profile_bot%\config.ini, general, zone_to_clean
			currZone = %_zone_to_clean2%
			TMP = 2
				
			sleep 200
			Send {%_EBReload%}
			TrayTip, , Zone changed! , 2
		}
		
		SetTimer, RemoveTT, 1000 
		_timeZoneChangeSec := ((_timeZoneChange * 60) -2)
	return

	; changing the zone to Zone3
	ZTC3:
		IfWinExist, %_name_bot_win%
		{
			WinActivate, %_name_poe_win%

			IniWrite, %_zone_to_clean_act3%, %_path_bot%\Configuration\%_profile_bot%\config.ini, general, zone_to_clean_act
			IniWrite, %_zone_to_clean_difficulty3%, %_path_bot%\Configuration\%_profile_bot%\config.ini, general, zone_to_clean_difficulty
			IniWrite, %_zone_to_clean3%, %_path_bot%\Configuration\%_profile_bot%\config.ini, general, zone_to_clean
			currZone = %_zone_to_clean3%
			TMP = 3
				
			sleep 200
			Send {%_EBReload%}
			TrayTip, , Zone changed! , 2
		}
		
		SetTimer, RemoveTT, 1000 
		_timeZoneChangeSec := ((_timeZoneChange * 60) -2)
	return
	
	; changing the zone to Zone4
	ZTC4:
		IfWinExist, %_name_bot_win%
		{
			WinActivate, %_name_poe_win%

			IniWrite, %_zone_to_clean_act4%, %_path_bot%\Configuration\%_profile_bot%\config.ini, general, zone_to_clean_act
			IniWrite, %_zone_to_clean_difficulty4%, %_path_bot%\Configuration\%_profile_bot%\config.ini, general, zone_to_clean_difficulty
			IniWrite, %_zone_to_clean4%, %_path_bot%\Configuration\%_profile_bot%\config.ini, general, zone_to_clean
			currZone = %_zone_to_clean4%
			TMP = 4
				
			sleep 200
			Send {%_EBReload%}
			TrayTip, , Zone changed! , 2
		}
		
		SetTimer, RemoveTT, 1000 
		_timeZoneChangeSec := ((_timeZoneChange * 60) -2)
	return
	
	; changing the zone to Zone5
	ZTC5:
		IfWinExist, %_name_bot_win%
		{
			WinActivate, %_name_poe_win%

			IniWrite, %_zone_to_clean_act5%, %_path_bot%\Configuration\%_profile_bot%\config.ini, general, zone_to_clean_act
			IniWrite, %_zone_to_clean_difficulty5%, %_path_bot%\Configuration\%_profile_bot%\config.ini, general, zone_to_clean_difficulty
			IniWrite, %_zone_to_clean5%, %_path_bot%\Configuration\%_profile_bot%\config.ini, general, zone_to_clean
			currZone = %_zone_to_clean5%
			TMP = 5
				
			sleep 200
			Send {%_EBReload%}
			TrayTip, , Zone changed! , 2
		}
		
		SetTimer, RemoveTT, 1000 
		_timeZoneChangeSec := ((_timeZoneChange * 60) -2)
	return

MyReload:
    Reload
Return

MyEdit:
    Edit
Return

; Simple Pause/Unpause Function
MyPause:
	F8::
	if A_IsPaused
	{
		Pause off
		TrayTip, %Menu1%%ver% unpaused!, Press F8 to pause Script again... , 1, 2
	}
	else
	{
		TrayTip, %Menu1%%ver% paused!, Press F8 to resume... , 1, 2
		Pause On
	}
return

RemoveTooltip:
	ToolTip
return

; inGame overlay for countdown until zoneChange
RemoveTT: 
	ToolTip, % (_timeZoneChangeSec--<1) ? "" : Menu1 Ver ":`n*********************************`nZone&stashTab change in : " FormatSeconds(_timeZoneChangeSec)"`nNext Zone will be : " currZone "`n`nCurrently used stashTab : "currStashTab, 310, 525
	If (_timeZoneChangeSec<0)
		SetTimer, RemoveTT, Off
return

; formating timeDisplay for the inGame overlay
FormatSeconds(x) 
{ 
Out:=SubStr("0" . Mod(x, 60),-1),x:=Floor(x/60)
Return x ":" Out
}

; randomization
Random(min,max) {
	Random, out, %min%, %max%
	return out
}

; simple exit routine
ExitSub:
	F9::
	TrayTip, , %Menu1%%ver% terminaetd! , 2
	ExitApp
return
